## lensfun 0.2.8

=== CMakeLists.txt ===
# require at least cmake 2.8
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR )

# path for helper modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/build/CMakeModules)
GET_FILENAME_COMPONENT(SOURCE_BASE_DIR ${CMAKE_SOURCE_DIR} PATH CACHE)

#  global setup
project(lensfun)

# version
SET(VERSION_MAJOR 0)
SET(VERSION_MINOR 2)
SET(VERSION_MICRO 8)
SET(VERSION_BUGFIX 0)

# check if some include are available
INCLUDE(CheckIncludeFiles)
CHECK_INCLUDE_FILES(regex.h HAVE_REGEX_H)
CHECK_INCLUDE_FILES(endian.h HAVE_ENDIAN_H)

# set include directories
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/lensfun)
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/auxfun)
IF(NOT HAVE_REGEX_H)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/regex)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/libs/regex)
ENDIF()

# options controlling the build process
OPTION(BUILD_STATIC "Build static library" OFF)
OPTION(BUILD_TESTS "Build test programs" ON)
OPTION(BUILD_AUXFUN "Build auxfun library (requires libpng)" OFF)
OPTION(BUILD_FOR_SSE "Build with support for SSE" OFF)
OPTION(BUILD_FOR_SSE2 "Build with support for SSE2" OFF)
OPTION(BUILD_DOC "Build documentation with doxygen" OFF)

IF(BUILD_FOR_SSE)
  SET(VECTORIZATION_SSE 1)
  IF(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse")
  ENDIF()
ENDIF()
IF(BUILD_FOR_SSE2)
  SET(VECTORIZATION_SSE2 1)
  IF(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
  ENDIF()
ENDIF()

IF(WIN32)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/libs/getopt)
  # base path for searching for glib on windows
  IF(NOT GLIB2_BASE_DIR)
    SET(GLIB2_BASE_DIR "${SOURCE_BASE_DIR}/glib-2.28.1" CACHE STRING "Base path of glib2 dir." FORCE)
  ENDIF()
ENDIF()

# find dependencies
FIND_PACKAGE(GLIB2 REQUIRED)
INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})

IF(BUILD_AUXFUN)
  FIND_PACKAGE(PNG REQUIRED)
  INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
  INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
  INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
ENDIF()

IF(BUILD_STATIC)
  ADD_DEFINITIONS(-DCONF_LENSFUN_STATIC)
ENDIF()
 
# define destination dirs (relative to prefix)
SET(BINDIR bin CACHE PATH "Directory for library example programs")
SET(LIBDIR lib${LIB_SUFFIX} CACHE PATH "Directory for library itself")
SET(INCLUDEDIR include CACHE PATH "Directory for library header files")
SET(DATADIR share/lensfun CACHE PATH "Directory for library data files")

IF(BUILD_DOC)
  SET(DOCDIR share/doc/lensfun-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX} CACHE PATH "Directory to put library documentation in")
ENDIF(BUILD_DOC)

IF(WIN32)
  # install into place in build-dir  
  SET(LENSFUN_INSTALL_PREFIX "${SOURCE_BASE_DIR}/lensfun" CACHE PATH "Install prefix for lensfun")    
ELSE()
  SET(LENSFUN_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Install prefix for lensfun")    
ENDIF()
SET(CMAKE_INSTALL_PREFIX "${LENSFUN_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)

IF(WIN32)
  SET(PLATFORM_WINDOWS 1)  
  
  IF (MSVC)
    IF(BUILD_STATIC)
      # compile everything for the static C runtime
      FOREACH(TYPE C CXX)
        # makefiles use blank configuration
        FOREACH(CFG "_DEBUG" "_MINSIZEREL" "_RELEASE" "_RELWITHDEBINFO")
          SET(NEW_FLAGS "${CMAKE_${TYPE}_FLAGS${CFG}}")
          # fix up static libc flags
          STRING(REPLACE "/MD" "/MT" NEW_FLAGS "${NEW_FLAGS}")
          # *FORCE* to override whats already placed into the cache
          SET(CMAKE_${TYPE}_FLAGS${CFG} "${NEW_FLAGS}" CACHE STRING
            "CMAKE_${TYPE}_FLAGS${CFG} (overwritten to ensure static build)" FORCE)
        ENDFOREACH(CFG)
      ENDFOREACH(TYPE)
      # link only with the static C runtime !! THIS IS A MUST !!
      SET(NEW_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
      # ensure that the flags are not duplicaated on subsequent runs
      STRING(REPLACE " /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\"" "" NEW_FLAGS "${NEW_FLAGS}")
      # note that flag names (NODEFAULTLIB) etc.) are case sensitive
      SET(CMAKE_EXE_LINKER_FLAGS
          "${NEW_FLAGS} /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\""
          CACHE STRING "for MSVC" FORCE
      )
    ENDIF()
  ENDIF(MSVC)
ENDIF(WIN32)

# create config.h file
CONFIGURE_FILE(include/lensfun/config.h.in.cmake ${CMAKE_BINARY_DIR}/config.h)
# create lensfun.h file
CONFIGURE_FILE(include/lensfun/lensfun.h.in ${CMAKE_BINARY_DIR}/lensfun.h @ONLY)

# include libs
ADD_SUBDIRECTORY(libs)

# include example programs
IF(BUILD_TESTS)
ADD_SUBDIRECTORY(tests)
ENDIF()

# install include files
INSTALL(FILES ${CMAKE_BINARY_DIR}/lensfun.h DESTINATION ${INCLUDEDIR}/lensfun)
IF(NOT HAVE_REGEX_H)
  INSTALL(FILES include/regex/regex.h DESTINATION ${INCLUDEDIR}/regex)
ENDIF()
IF(BUILD_AUXFUN)
  INSTALL(FILES include/auxfun/image.h include/auxfun/rgbpixel.h DESTINATION ${INCLUDEDIR}/auxfun)
ENDIF()

# install db files
FILE(GLOB DATABASE_FILES data/db/*.xml)
INSTALL(FILES ${DATABASE_FILES} DESTINATION ${DATADIR})

# build documentation
IF(BUILD_DOC)
  ADD_SUBDIRECTORY(docs)
ENDIF()

IF(WIN32 AND NOT BUILD_STATIC)
FIND_FILE(GLIB2_DLL 
          NAMES glib-2.dll glib-2-vs9.dll
          PATHS "${GLIB2_BASE_DIR}/bin"
          NO_SYSTEM_ENVIRONMENT_PATH)
INSTALL(FILES ${GLIB2_DLL} DESTINATION ${BINDIR})
ENDIF()

# print some information
MESSAGE(STATUS "Building lensfun ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}")
MESSAGE(STATUS "-------------------------------------------------------------------------------------")
IF(BUILD_STATIC)
  MESSAGE(STATUS "Build as static library")
ELSE()
  MESSAGE(STATUS "Build as dynamic/shared library")
ENDIF()
MESSAGE(STATUS "Build doc: ${BUILD_DOC}")
MESSAGE(STATUS "Build test programs ${BUILD_TESTS}")
IF(BUILD_AUXFUN)
  MESSAGE(STATUS "Building auxfun library (with Image class)")
ENDIF()
MESSAGE(STATUS "Build with support for SSE: ${BUILD_FOR_SSE}")
MESSAGE(STATUS "Build with support for SSE2: ${BUILD_FOR_SSE2}")
MESSAGE(STATUS "Install prefix: ${LENSFUN_INSTALL_PREFIX}")
MESSAGE(STATUS "\nUsing: ")
MESSAGE(STATUS "GLIB2 include dir: ${GLIB2_INCLUDE_DIRS}")
MESSAGE(STATUS "GLIB2 library: ${GLIB2_LIBRARIES}")
IF(BUILD_AUXFUN)
MESSAGE(STATUS "libpng include dir: ${PNG_INCLUDE_DIR}")
MESSAGE(STATUS "libpng lib: ${PNG_LIBRARY}")
MESSAGE(STATUS "zlib include dir: ${ZLIB_INCLUDE_DIR}")
MESSAGE(STATUS "zlib lib: ${ZLIB_LIBRARY}")
ENDIF()

# Package
# This needs some testing, in particular for right package naming for different
# package managers and distributions. Debian works fine.
SET(CPACK_PACKAGE_NAME "lensfun")
SET(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_MICRO}.${VERSION_BUGFIX}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${V_MAJOR}.${V_MINOR}")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}")
SET(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
SET(CPACK_PACKAGE_CONTACT "zap@homelink.ru")
SET(CPACK_SET_DESTDIR "ON")
IF(BUILD_AUXFUN)
SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libglib2.0-0 (>=2.0.0), libpng (>=1.0), zlib (>=1.0)")
ELSE()
SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libglib2.0-0 (>=2.0.0)")
ENDIF()

IF(CPACK_BINARY_DEB)
    # workaround to set correct debian package name
    SET(CPACK_DEBIAN_PACKAGE_NAME "liblensfun${VERSION_MAJOR}")
    string(TOLOWER "${CPACK_DEBIAN_PACKAGE_NAME}" CPACK_PACKAGE_NAME_LOWERCASE)
    find_program(DPKG_PROGRAM dpkg DOC "dpkg program of Debian-based systems")
    if(DPKG_PROGRAM)
        execute_process(
            COMMAND ${DPKG_PROGRAM} --print-architecture
            OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
    else(DPKG_PROGRAM)
        set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}_${CMAKE_SYSTEM_NAME}")
    endif(DPKG_PROGRAM)
ENDIF(CPACK_BINARY_DEB)

INCLUDE(CPack)

=== docs/CMakeLists.txt ===
# find doxygen
FIND_PACKAGE(Doxygen REQUIRED)

# set some files/path for later user
# we don't use path doc because path doc is used by cmake itself because
# of target doc
SET(CMAKE_DOC_OUT ${CMAKE_BINARY_DIR}/doc_doxygen)
set(DOXYFILE "${CMAKE_CURRENT_BINARY_DIR}/doxyfile")

# create doxyfile
CONFIGURE_FILE(doxyfile.in.cmake ${DOXYFILE} @ONLY)

# now build documentation
ADD_CUSTOM_TARGET(doc
  ALL
  COMMAND "${DOXYGEN_EXECUTABLE}"
  DEPENDS "${DOXYFILE}" manual-main.txt ../include/lensfun/lensfun.h.in
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMENT "Building documentation with doxygen"
)

# install documentation  
INSTALL(DIRECTORY ${CMAKE_DOC_OUT}/ DESTINATION ${DOCDIR})

=== libs/CMakeLists.txt ===
IF(NOT HAVE_REGEX_H)
  ADD_SUBDIRECTORY(regex)
ENDIF()

ADD_SUBDIRECTORY(lensfun)

IF(BUILD_AUXFUN)
  ADD_SUBDIRECTORY(auxfun)
ENDIF()

# also build getopt on windows
IF(WIN32 AND BUILD_TESTS)
  ADD_SUBDIRECTORY(getopt)
ENDIF()

=== tests/CMakeLists.txt ===
IF(WIN32)
  SET(COMMON_LIBS getopt)
ENDIF()

ADD_EXECUTABLE(example example/example.c)
TARGET_LINK_LIBRARIES(example lensfun ${COMMON_LIBS})

ADD_EXECUTABLE(tfun tfun/tfun.cpp)
TARGET_LINK_LIBRARIES(tfun lensfun ${COMMON_LIBS})

ADD_EXECUTABLE(trwxml trwxml/trwxml.cpp)
TARGET_LINK_LIBRARIES(trwxml lensfun ${COMMON_LIBS})

INSTALL(TARGETS example tfun trwxml DESTINATION ${BINDIR})

IF(BUILD_AUXFUN)
ADD_EXECUTABLE(tmod tmod/tmod.cpp)
TARGET_LINK_LIBRARIES(tmod lensfun auxfun ${COMMON_LIBS} ${PNG_LIBRARY} ${ZLIB_LIBRARY})
INSTALL(TARGETS tmod DESTINATION ${BINDIR})
ENDIF()

=== libs/auxfun/CMakeLists.txt ===
# build auxfun lib
SET(AUXFUN_SRC ../../include/auxfun/image.h ../../include/auxfun/rgbpixel.h image.cpp)
IF(BUILD_STATIC)
ADD_LIBRARY(auxfun STATIC ${AUXFUN_SRC})
ELSE()
ADD_LIBRARY(auxfun SHARED ${AUXFUN_SRC})
ENDIF()

SET_TARGET_PROPERTIES(auxfun PROPERTIES SOVERSION "${VERSION_MAJOR}" VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}")  
TARGET_LINK_LIBRARIES(auxfun ${PNG_LIBRARY} ${ZLIB_LIBRARY})
INSTALL(TARGETS auxfun 
    RUNTIME DESTINATION ${BINDIR}
    LIBRARY DESTINATION ${LIBDIR}
    ARCHIVE DESTINATION ${LIBDIR})

=== libs/lensfun/CMakeLists.txt ===
# build lensfun library
SET(LENSFUN_SRC camera.cpp database.cpp lens.cpp 
                mount.cpp lensfunprv.h cpuid.cpp 
                mod-color-sse2.cpp mod-color.cpp 
                mod-coord-sse.cpp mod-coord.cpp
                mod-subpix.cpp modifier.cpp auxfun.cpp
                ../../include/lensfun/lensfun.h.in)
IF(WIN32)
  LIST(APPEND LENSFUN_SRC windows/auxfun.cpp)
ENDIF()

IF(BUILD_STATIC)
  ADD_LIBRARY(lensfun STATIC ${LENSFUN_SRC})
ELSE()
  ADD_LIBRARY(lensfun SHARED ${LENSFUN_SRC})
  SET_TARGET_PROPERTIES(lensfun PROPERTIES COMPILE_FLAGS -DCONF_SYMBOL_VISIBILITY)
ENDIF()
SET_TARGET_PROPERTIES(lensfun PROPERTIES SOVERSION "${VERSION_MAJOR}" VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}")  

IF(NOT HAVE_REGEX_H)
  TARGET_LINK_LIBRARIES(lensfun tre_regex)
ENDIF()
TARGET_LINK_LIBRARIES(lensfun ${GLIB2_LIBRARIES})

INSTALL(TARGETS lensfun 
        RUNTIME DESTINATION ${BINDIR}
        LIBRARY DESTINATION ${LIBDIR}
        ARCHIVE DESTINATION ${LIBDIR})

# pkgconfig support
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/lensfun.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/lensfun.pc @ONLY)
INSTALL( FILES ${CMAKE_CURRENT_BINARY_DIR}/lensfun.pc DESTINATION ${LIBDIR}/pkgconfig )

## lensfun 0.2.7

=== debian/changelog ===
lensfun (0.2.7-0ubuntu1) raring; urgency=low

  * New upstream release (LP: #1084730)
  * Switch to new cmake based buildsystem as the old one doesn't create
    a properly versioned library anymore and is deprecated
    - Add build-dep on cmake
    - Drop buil-dep on autotools-dev
  * Port package from cdbs to dh7 style rules 
    - Build-Depend on debhelper >= 7.0.50~
    - Drop build-dep on cdbs
    - rewrite rules to use dh instead of cdbs
    into the right path again
  * Add ubuntu_build_docs.diff so the documentation is built and installed
  * Update liblensfun-doc.install as the documentation is now installed into
    the right location right away
  * Switch to source format 3.0 (quilt) for quilt support

 -- Philip Muškovac <yofel@kubuntu.org>  Mon, 25 Feb 2013 20:49:11 +0100

lensfun (0.2.5-2) unstable; urgency=low

  * Drop symbol support (Closes: #589048) 
  * Fix "liblensfun packages seem to miss some documentation" 
    missing dir added to liblensfun-doc.install (Closes: #617547)

 -- Mark Purcell <msp@debian.org>  Sun, 22 Jan 2012 13:40:44 +1100

lensfun (0.2.5-1) experimental; urgency=low

  * New upstream release (Closes: #576230)
    - Upload to experimental whilst we investigate symbols
  * disable --vectorization= while we workout howto cross platform

 -- Mark Purcell <msp@debian.org>  Wed, 14 Jul 2010 21:01:12 +1000

lensfun (0.2.4-1) unstable; urgency=low

  * New upstream release

  [ Didier Raboud ]
  * In debian/control, write a new common description for the binary packages
    (Closes: #522168)

  [ Stefan Potyra ] 
  * Add 10-makedep-fix-ftbfs patch to fix FTBFS.
  * Add 20-enum-sentinel patch to have g++-4.4 not remove the otherwise
    unreachable code handling out-of-bounds enum values via the
    c-wrapper functions. LP: #433368.
   
  [ Pascal de Bruijn ]
  * Drop all previous lensfun database patches.
  * Add 90-lensfun-db-update-rel-to-svn65 patch, to update the lensfun 
    database to revision 65 of lensfun svn.
  * Add 91-lensfun-db-update-svn65-to-pmjdebruijn patch, to update the
    lensfun database from revision 65 to pmjdebruijn's local tree.

  [ Mark Purcell ]
  * Update debian/watch
  * Drop debian/patches & dpatch as included upstream 0.2.4 

 -- Mark Purcell <msp@debian.org>  Mon, 26 Oct 2009 08:12:51 +1100

lensfun (0.2.3-2) unstable; urgency=low

  [ Luka Renko ]
  * rules: add --libdir=/usr/lib to ./configure for amd64 libraries.
    (Closes: #516657)
  * Update debian/liblensfun0.symbols to match all symbols.

  [ Pascal de Bruijn ]
  * Added patches:
    - 01-lensfun-db-cameras-generic (APS-H, FourThirds)
    - 02-lensfun-db-cameras-canon (5DmkII, 50D, 30D)
    - 03-lensfun-db-cameras-nikon (D40, D40X, D60, D80, D90, D700, D3, D3X)
    - 04-lensfun-db-cameras-pentax (K100D, K200D, K10D, K20D)
    - 05-lensfun-db-cameras-samsung (GX20)
  * Split up the data package into a data and doc package.

  [ Mark Purcell ]
  * Update Maintainer: Debian KDE Extras Team.

 -- Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>  Thu, 19 Mar 2009 23:26:51 +0100

lensfun (0.2.3-1) unstable; urgency=low

  * Initial release (Closes: #509242)

 -- Mark Purcell <msp@debian.org>  Wed, 07 Jan 2009 09:47:45 +1100

=== debian/control ===
Source: lensfun
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>
Build-Depends: debhelper (>= 7.0.50~), cmake, python, doxygen, libglib2.0-dev, libpng12-dev
Standards-Version: 3.8.1
Section: libs
Homepage: http://lensfun.berlios.de

Package: liblensfun-dev
Section: libdevel
Architecture: any
Depends: liblensfun0 (= ${binary:Version}), ${misc:Depends}
Description: Lens Correction library - Development files
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related softwares in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the development files.

Package: liblensfun0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, liblensfun-data
Description: Lens Correction library - Runtime files
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related softwares in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the runtime files to access the library.

Package: liblensfun-data
Architecture: all
Depends: ${misc:Depends}
Description: Lens Correction library - Data
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related softwares in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the data collection.

Package: liblensfun-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Lens Correction library - Documentation
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related softwares in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh "$@" --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DOC=ON -DDOCDIR="share/doc/liblensfun-doc"

override_dh_auto_clean:
	find -name "*.pyc" -exec rm -f '{}' \;
	dh_auto_clean

=== debian/watch ===
version=3
http://download.berlios.de/lensfun/ lensfun-(.*).tar.bz2 debian svn-upgrade

## lensfun 0.2.8

=== debian/changelog ===
lensfun (0.2.8-2) unstable; urgency=medium

  * Team upload.
  * The project moved from Berlios to Sourceforce, so:
    - update Homepage to http://lensfun.sourceforge.net
    - update watch file to look on sf.net
  * Add Vcs-* headers.
  * Simplify/improve/sort .install files.
  * Do not build the documentation on arch-only builds:
    - move the doxygen build dependency to Build-Depends-Indep
    - explicitly disable the documentation build (i.e. pass -DBUILD_DOC=OFF
      to cmake) when not producing -doc packages
  * Add the pkg-config build dependency.
  * Bump the priority to optional, since it is used by other "optional"
    sources.

 -- Pino Toscano <pino@debian.org>  Mon, 08 Sep 2014 09:01:51 +0200

lensfun (0.2.8-1) unstable; urgency=low

  * New upstream release
  * Add --parallel
  * Add -DDOCDIR="/usr/share/doc/liblensfun-doc/html"
  * Add +docs/adobe-lens-profile.txt
  * Bump shlibs - dh_makeshlibs -V 'liblensfun0 (>= 0.2.8)'
  * Bump Standards-Version: 3.9.5 - no further changes

 -- Mark Purcell <msp@debian.org>  Sat, 09 Nov 2013 16:32:20 +1100

lensfun (0.2.7-3) unstable; urgency=low

  [Andreas Metzler]
  * Bump shlibs. Closes: #722406

 -- Mark Purcell <msp@debian.org>  Sun, 12 May 2013 17:27:17 +1000

lensfun (0.2.7-2) unstable; urgency=low

  * Upload to unstable

 -- Mark Purcell <msp@debian.org>  Sun, 12 May 2013 10:17:02 +1000

lensfun (0.2.7-1) experimental; urgency=low

  * New upstream release
    - Fixes "new upstream version" (Closes: #679113)
    - Fixes "FTBFS with libpng 1.5" (Closes: #648130)
  * Update debian/watch - Thanks Bart
  * Fixed "Build-Depends on libpng-dev" (Closes: #662391)
  * Switch to cmake - Thanks yofel@kubuntu.org 
  * debian/compat -> 9

 -- Mark Purcell <msp@debian.org>  Sat, 09 Mar 2013 14:29:47 +1100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: lensfun
-Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Priority: optional
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Mark Purcell <msp@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), cmake, python, doxygen, libglib2.0-dev, libpng12-dev
-Standards-Version: 3.8.1
+Build-Depends: debhelper (>= 9), cmake, pkg-config, python, libglib2.0-dev,
+ libpng-dev
+Build-Depends-Indep: doxygen
+Standards-Version: 3.9.5
 Section: libs
-Homepage: http://lensfun.berlios.de
+Homepage: http://lensfun.sourceforge.net
+Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/lensfun/trunk
+Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/lensfun/trunk
 
 Package: liblensfun-dev
 Section: libdevel
@@ -19,7 +22,7 @@
   * cameras
   * lenses
  .
- It is used in various photo-related softwares in which it allows the
+ It is used in various photo-related software in which it allows the
  correction of various artifacts:
   * distortion
   * transveral (also known as lateral) chromatic aberrations
@@ -41,7 +44,7 @@
   * cameras
   * lenses
  .
- It is used in various photo-related softwares in which it allows the
+ It is used in various photo-related software in which it allows the
  correction of various artifacts:
   * distortion
   * transveral (also known as lateral) chromatic aberrations
@@ -63,7 +66,7 @@
   * cameras
   * lenses
  .
- It is used in various photo-related softwares in which it allows the
+ It is used in various photo-related software in which it allows the
  correction of various artifacts:
   * distortion
   * transveral (also known as lateral) chromatic aberrations
@@ -86,7 +89,7 @@
   * cameras
   * lenses
  .
- It is used in various photo-related softwares in which it allows the
+ It is used in various photo-related software in which it allows the
  correction of various artifacts:
   * distortion
   * transveral (also known as lateral) chromatic aberrations

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
ifneq (,$(filter %-doc,$(shell dh_listpackages)))
	dh_auto_configure -- -DBUILD_DOC=ON -DDOCDIR="/usr/share/doc/liblensfun-doc/html"
else
	dh_auto_configure -- -DBUILD_DOC=OFF
endif

override_dh_auto_clean:
	find -name "*.pyc" -exec rm -f '{}' \;
	dh_auto_clean

override_dh_makeshlibs:
	dh_makeshlibs -V 'liblensfun0 (>= 0.2.8)'

=== debian/watch ===
version=3

http://sf.net/lensfun/lensfun-([0-9\.]*)\.tar\.(?:bz2|xz) debian svn-upgrade

## lensfun 0.3.2

=== CMakeLists.txt ===
# require at least cmake 2.8
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR )

# path for helper modules
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/modules")
GET_FILENAME_COMPONENT(SOURCE_BASE_DIR ${CMAKE_SOURCE_DIR} PATH CACHE)

#  global setup
project(lensfun C CXX)

# version
SET(VERSION_MAJOR 0)
SET(VERSION_MINOR 3)
SET(VERSION_MICRO 2)
SET(VERSION_BUGFIX 0)
SET(VERSION_API 1)
# This is the version of the *shipped* database, which is not necessarily the
# highest version number supported
SET(LENSFUN_DB_VERSION 1)

# check if some include are available
INCLUDE(CheckIncludeFiles)
CHECK_INCLUDE_FILES(regex.h HAVE_REGEX_H)
CHECK_INCLUDE_FILES(endian.h HAVE_ENDIAN_H)

# set include directories
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/lensfun)
IF(NOT HAVE_REGEX_H)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/regex)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/libs/regex)
ENDIF()

# options controlling the build process
OPTION(BUILD_STATIC "Build static library" OFF)
OPTION(BUILD_TESTS "Build test suite" OFF)
OPTION(BUILD_LENSTOOL "Build the lenstool (requires libpng)" OFF)
OPTION(BUILD_FOR_SSE "Build with support for SSE" ON)
OPTION(BUILD_FOR_SSE2 "Build with support for SSE2" ON)
OPTION(BUILD_DOC "Build documentation with doxygen" OFF)
OPTION(INSTALL_HELPER_SCRIPTS "Install various helper scripts" ON)

IF(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug CACHE STRING
       "Choose the type of build, options are: Debug, Release"
       FORCE
  )
ENDIF()

# set local install prefix on windows
IF(WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)  
  SET(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/install" CACHE PATH "Install prefix for Lensfun" FORCE)    
ENDIF()
# get standard GNU install directories for the current platform
INCLUDE(GNUInstallDirs)
IF(NOT DEFINED CMAKE_INSTALL_DATAROOTDIR)
  SET(CMAKE_INSTALL_DATAROOTDIR "share" CACHE PATH "read-only architecture-independent data root (share)")
ENDIF()
IF (WIN32)
    SET(LENSFUN_WINDOWS_DATADIR ${CMAKE_INSTALL_DATAROOTDIR}/lensfun CACHE PATH "Directory for library data files. This should be relative to the location where the lensfun.dll will be installed.")
ENDIF()

IF(BUILD_FOR_SSE)
  SET(VECTORIZATION_SSE 1)
  IF(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse")
  ENDIF()
ENDIF()
IF(BUILD_FOR_SSE2)
  SET(VECTORIZATION_SSE2 1)
  IF(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
  ENDIF()
ENDIF()

IF(WIN32)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/libs/getopt)
  # base path for searching for glib on windows
  IF(NOT GLIB2_BASE_DIR)
    SET(GLIB2_BASE_DIR "${SOURCE_BASE_DIR}/glib-2.28.1" CACHE STRING "Base path of glib2 dir." FORCE)
  ENDIF()
  # install glib dll on windows next to lensfun.dll
  IF (GLIB2_DLL)
    INSTALL(FILES ${GLIB2_DLL} DESTINATION ${CMAKE_INSTALL_BINDIR})
  ENDIF()
ENDIF()

# find dependencies
# NOTE: must be one of the macros listed in https://developer.gnome.org/glib/stable/glib-Version-Information.html
SET(LENSFUN_GLIB_REQUIREMENT_MACRO "GLIB_VERSION_2_40")
FIND_PACKAGE(GLIB2 REQUIRED 2.40)

INCLUDE_DIRECTORIES(SYSTEM ${GLIB2_INCLUDE_DIRS})


IF(BUILD_STATIC)
  ADD_DEFINITIONS(-DCONF_LENSFUN_STATIC)
ENDIF()


# some windows and MSVC specific settings
IF(WIN32)
  SET(PLATFORM_WINDOWS 1)  
  
  IF (MSVC)
    IF(BUILD_STATIC)
      # compile everything for the static C runtime
      FOREACH(TYPE C CXX)
        # makefiles use blank configuration
        FOREACH(CFG "_DEBUG" "_MINSIZEREL" "_RELEASE" "_RELWITHDEBINFO")
          SET(NEW_FLAGS "${CMAKE_${TYPE}_FLAGS${CFG}}")
          # fix up static libc flags
          STRING(REPLACE "/MD" "/MT" NEW_FLAGS "${NEW_FLAGS}")
          # *FORCE* to override whats already placed into the cache
          SET(CMAKE_${TYPE}_FLAGS${CFG} "${NEW_FLAGS}" CACHE STRING
            "CMAKE_${TYPE}_FLAGS${CFG} (overwritten to ensure static build)" FORCE)
        ENDFOREACH(CFG)
      ENDFOREACH(TYPE)
      # link only with the static C runtime !! THIS IS A MUST !!
      SET(NEW_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
      # ensure that the flags are not duplicaated on subsequent runs
      STRING(REPLACE " /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\"" "" NEW_FLAGS "${NEW_FLAGS}")
      # note that flag names (NODEFAULTLIB) etc.) are case sensitive
      SET(CMAKE_EXE_LINKER_FLAGS
          "${NEW_FLAGS} /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\""
          CACHE STRING "for MSVC" FORCE
      )
    ENDIF()
  ENDIF(MSVC)
ENDIF(WIN32)

# create config.h file
CONFIGURE_FILE(include/lensfun/config.h.in.cmake ${CMAKE_BINARY_DIR}/config.h)
# create lensfun.h file
CONFIGURE_FILE(include/lensfun/lensfun.h.in ${CMAKE_BINARY_DIR}/lensfun.h @ONLY)

# include libs
ADD_SUBDIRECTORY(libs)

# build the test suite
IF(BUILD_TESTS)
    enable_testing()
    ADD_SUBDIRECTORY(tests)
ENDIF()

# apps subdir
ADD_SUBDIRECTORY(apps)

# install include files
INSTALL(FILES ${CMAKE_BINARY_DIR}/lensfun.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lensfun)
IF(NOT HAVE_REGEX_H)
  INSTALL(FILES include/regex/regex.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/regex)
ENDIF()

# install db files
FILE(GLOB DATABASE_FILES data/db/*.xml)
INSTALL(FILES ${DATABASE_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/lensfun/version_${LENSFUN_DB_VERSION})
INSTALL(FILES data/db/timestamp.txt DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/lensfun/version_${LENSFUN_DB_VERSION})

# build documentation
IF(BUILD_DOC)
  ADD_SUBDIRECTORY(docs)
ENDIF()

IF(WIN32 AND NOT BUILD_STATIC)
  FIND_FILE(GLIB2_DLL 
            NAMES glib-2.dll glib-2-vs9.dll
            PATHS "${GLIB2_BASE_DIR}/bin"
            NO_SYSTEM_ENVIRONMENT_PATH)
  INSTALL(FILES ${GLIB2_DLL} DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

# print some information
MESSAGE(STATUS "-------------------------------------------------------------------------------------")
MESSAGE(STATUS "Building Lensfun ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}")
MESSAGE(STATUS "-------------------------------------------------------------------------------------")
IF(BUILD_STATIC)
  MESSAGE(STATUS "Build as static library")
ELSE()
  MESSAGE(STATUS "Build as dynamic/shared library")
ENDIF()
MESSAGE(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "Build doc: ${BUILD_DOC}")
MESSAGE(STATUS "Build test suite: ${BUILD_TESTS}")
MESSAGE(STATUS "Build lenstool: ${BUILD_LENSTOOL}")
MESSAGE(STATUS "Build with support for SSE: ${BUILD_FOR_SSE}")
MESSAGE(STATUS "Build with support for SSE2: ${BUILD_FOR_SSE2}")
MESSAGE(STATUS "Install helper scripts: ${INSTALL_HELPER_SCRIPTS}")
MESSAGE(STATUS "\nInstall prefix: ${CMAKE_INSTALL_PREFIX}")
MESSAGE(STATUS "\nUsing: ")
MESSAGE(STATUS "GLIB2 include dir: ${GLIB2_INCLUDE_DIRS}")
MESSAGE(STATUS "GLIB2 library: ${GLIB2_LIBRARIES}")
IF(GLIB2_DLL)
MESSAGE(STATUS "GLIB2 DLL: ${GLIB2_DLL}")
ENDIF()
IF(BUILD_APPS)
MESSAGE(STATUS "libpng include dir: ${PNG_INCLUDE_DIR}")
MESSAGE(STATUS "libpng lib: ${PNG_LIBRARY}")
MESSAGE(STATUS "zlib include dir: ${ZLIB_INCLUDE_DIR}")
MESSAGE(STATUS "zlib lib: ${ZLIB_LIBRARY}")
ENDIF()

# Package
# This needs some testing, in particular for right package naming for different
# package managers and distributions. Debian works fine.
SET(CPACK_PACKAGE_NAME "lensfun")
SET(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_MICRO}.${VERSION_BUGFIX}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${V_MAJOR}.${V_MINOR}")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}")
SET(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
SET(CPACK_PACKAGE_CONTACT "zap@homelink.ru")
SET(CPACK_SET_DESTDIR "ON")
IF(BUILD_AUXFUN)
  SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libglib2.0-0 (>=2.0.0), libpng (>=1.0), zlib (>=1.0)")
ELSE()
  SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libglib2.0-0 (>=2.0.0)")
ENDIF()

IF(CPACK_BINARY_DEB)
  # workaround to set correct debian package name
  SET(CPACK_DEBIAN_PACKAGE_NAME "liblensfun${VERSION_API}")
  STRING(TOLOWER "${CPACK_DEBIAN_PACKAGE_NAME}" CPACK_PACKAGE_NAME_LOWERCASE)
  FIND_PROGRAM(DPKG_PROGRAM dpkg DOC "dpkg program of Debian-based systems")
  if(DPKG_PROGRAM)
      EXECUTE_PROCESS(
          COMMAND ${DPKG_PROGRAM} --print-architecture
          OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE
          OUTPUT_STRIP_TRAILING_WHITESPACE
      )
      SET(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
  else(DPKG_PROGRAM)
      SET(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}_${CMAKE_SYSTEM_NAME}")
  endif(DPKG_PROGRAM)
ENDIF(CPACK_BINARY_DEB)

INCLUDE(CPack)

=== apps/CMakeLists.txt ===
IF(WIN32)
  SET(COMMON_LIBS getopt)
ENDIF()

IF(BUILD_LENSTOOL)
    FIND_PACKAGE(PNG REQUIRED)
    INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
    ADD_EXECUTABLE(lenstool lenstool/lenstool.cpp lenstool/image.cpp)
    TARGET_LINK_LIBRARIES(lenstool lensfun ${COMMON_LIBS} ${PNG_LIBRARY} ${ZLIB_LIBRARY})
    INSTALL(TARGETS lenstool DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()


IF(INSTALL_HELPER_SCRIPTS)
  INSTALL(PROGRAMS g-lensfun-update-data lensfun-add-adapter lensfun-update-data
          DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF(INSTALL_HELPER_SCRIPTS)


# Inspired by http://bloerg.net/2012/11/10/cmake-and-distutils.html

FIND_PROGRAM(PYTHON "python3")
IF(PYTHON)
    SET(SETUP_PY_IN "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
    SET(SETUP_PY    "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
    SET(DEPS_IN     "${CMAKE_CURRENT_SOURCE_DIR}/lensfun/__init__.py.in")
    SET(DEPS        "${CMAKE_CURRENT_BINARY_DIR}/lensfun/__init__.py")
    SET(OUTPUT      "${CMAKE_CURRENT_BINARY_DIR}/build/timestamp")

    CONFIGURE_FILE(${SETUP_PY_IN} ${SETUP_PY})
    CONFIGURE_FILE(${DEPS_IN} ${DEPS})

    ADD_CUSTOM_COMMAND(OUTPUT ${OUTPUT}
                       COMMAND ${PYTHON} ${SETUP_PY} build
                       COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
                       DEPENDS ${DEPS_IN})

    ADD_CUSTOM_TARGET(python-package ALL DEPENDS ${OUTPUT})

    IF(NOT DEFINED SETUP_PY_INSTALL_PREFIX)
      SET(SETUP_PY_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
    ENDIF()
    INSTALL(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} install --prefix=${SETUP_PY_INSTALL_PREFIX})")
ENDIF(PYTHON)

=== libs/CMakeLists.txt ===
IF(NOT HAVE_REGEX_H)
  ADD_SUBDIRECTORY(regex)
ENDIF()

ADD_SUBDIRECTORY(lensfun)

# also build getopt on windows
IF(WIN32 AND BUILD_TESTS)
  ADD_SUBDIRECTORY(getopt)
ENDIF()

=== tests/CMakeLists.txt ===
ADD_EXECUTABLE(test_database test_database.cpp)
TARGET_LINK_LIBRARIES(test_database lensfun ${COMMON_LIBS})
ADD_TEST(Database test_database)

ADD_EXECUTABLE(test_modifier test_modifier.cpp)
TARGET_LINK_LIBRARIES(test_modifier lensfun ${COMMON_LIBS})
ADD_TEST(Modifier test_modifier)

find_package(OpenMP)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

ADD_EXECUTABLE(test_modifier_color test_modifier_color.cpp)
TARGET_LINK_LIBRARIES(test_modifier_color lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_color test_modifier_color)

ADD_EXECUTABLE(test_modifier_subpix test_modifier_subpix.cpp)
TARGET_LINK_LIBRARIES(test_modifier_subpix lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_subpix test_modifier_subpix)

ADD_EXECUTABLE(test_modifier_coord_scale test_modifier_coord_scale.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_scale lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_scale test_modifier_coord_scale)

ADD_EXECUTABLE(test_modifier_coord_distortion test_modifier_coord_distortion.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_distortion lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_distortion test_modifier_coord_distortion)

ADD_EXECUTABLE(test_modifier_coord_geometry test_modifier_coord_geometry.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_geometry lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_geometry test_modifier_coord_geometry)

FIND_PACKAGE(PythonInterp REQUIRED)
ADD_TEST(NAME Database_integrity COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/check_database/check_database.py ../../data/db)

=== libs/lensfun/CMakeLists.txt ===
# build Lensfun library
SET(LENSFUN_SRC camera.cpp database.cpp lens.cpp 
                mount.cpp lensfunprv.h cpuid.cpp 
                mod-color-sse.cpp mod-color-sse2.cpp mod-color.cpp
                mod-coord-sse.cpp mod-coord.cpp
                mod-subpix.cpp modifier.cpp auxfun.cpp
                ../../include/lensfun/lensfun.h.in)
IF(WIN32)
  LIST(APPEND LENSFUN_SRC windows/auxfun.cpp)
ENDIF()

IF(BUILD_STATIC)
  ADD_LIBRARY(lensfun STATIC ${LENSFUN_SRC})
ELSE()
  ADD_LIBRARY(lensfun SHARED ${LENSFUN_SRC})
  SET_TARGET_PROPERTIES(lensfun PROPERTIES COMPILE_FLAGS -DCONF_SYMBOL_VISIBILITY)
ENDIF()
SET_TARGET_PROPERTIES(lensfun PROPERTIES SOVERSION "${VERSION_API}" VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}")

IF(NOT HAVE_REGEX_H)
  TARGET_LINK_LIBRARIES(lensfun tre_regex)
ENDIF()
TARGET_LINK_LIBRARIES(lensfun ${GLIB2_LIBRARIES})

INSTALL(TARGETS lensfun 
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

# pkgconfig support
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/lensfun.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/lensfun.pc @ONLY)
INSTALL( FILES ${CMAKE_CURRENT_BINARY_DIR}/lensfun.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )

=== debian/changelog ===
lensfun (0.3.2-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Pino Toscano ]
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Use /usr/share/dpkg/architecture.mk instead of manually querying for
    $DEB_HOST_ARCH_CPU.
  * Add Rules-Requires-Root: no.
  * Bump Standards-Version to 4.5.1, no changes required.

  [ Helmut Grohne ]
  * Drop unused Build-Depends: libpng-dev as -DBUILD_LENSTOOL=ON is not
    passed. (Closes: #981312)

 -- Pino Toscano <pino@debian.org>  Sun, 07 Feb 2021 12:02:55 +0100

lensfun (0.3.2-5) unstable; urgency=medium

  * Switch Vcs-* fields to salsa.debian.org.
  * Switch Homepage to https://lensfun.github.io/.
  * Update watch file to point to github.com.
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
    - drop the dh_makeshlibs override, as -V is done by default
    - stop passing --list-missing to dh_missing, as it is done by default
    - stop excluding examples from dh_compress, as it is done by default
  * Remove empty line at the end of control.
  * Add the configuration for the CI on salsa.
  * Bump Standards-Version to 4.5.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Fri, 31 Jan 2020 11:39:30 +0100

lensfun (0.3.2-4) unstable; urgency=medium

  * Add the dh-python build dependency, now explicitly required.
  * Bump Standards-Version to 4.1.4, no changes required.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Fix typo in copyright.
  * Switch from dh_install to dh_missing for --list-missing.
  * Remove trailing whitespaces in changelog.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Apr 2018 08:12:25 +0200

lensfun (0.3.2-3) unstable; urgency=medium

  * Upload to unstable (see #821190).
  * Update Vcs-Browser field.
  * Bump Standards-Version to 3.9.8, no changes required.
  * Add myself to Uploaders.

 -- Pino Toscano <pino@debian.org>  Sat, 16 Apr 2016 18:35:43 +0200

lensfun (0.3.2-2) experimental; urgency=medium

  * Team upload.
  * Enable SSE and SSE2 only when building explicitly on amd64 CPUs, disabled
    otherwise.

 -- Pino Toscano <pino@debian.org>  Tue, 12 Jan 2016 18:41:59 +0100

lensfun (0.3.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release (Closes: #771838) (LP: #1455216)
  * Rename liblensfun0 to liblensfun1 according to the new upstream SONAME.
  * Delete the build_docs.diff patch, it was not applied in previous versions
    already.
  * Rename liblensfun-data to liblensfun-data-v1, following upstream's
    indications about the separate versioning of the lensfun database.
  * Update .install files.
  * Mark liblensfun1 as "Multi-Arch: same".
  * Replace the python build dependency with python3, as it's what upstream
    uses now.
  * Add two new binary packages: liblensfun-bin (with utilities), and
    python3-lensfun (Python 3 module).
    - use the python3 dh addon to handle the python3 packaging
  * Rename the DOCDIR parameter for cmake to CMAKE_INSTALL_DOCDIR, as upstream
    uses GNUInstallDirs.cmake now.
  * Rework the building of the documentation: since BUILD_DOC enables other
    documentation than the API docs, we always need to enable it:
    - move doxygen as proper build dependency
    - always enable BUILD_DOC in cmake
    - add the python3-docutils build dependency, needed for rst2man
  * Use a locally installed mathjax instead of a remote version:
    - point the doxygen configurations to the local path; patch
      local-mathjax.diff
    - add the libjs-mathjax dependency to liblensfun-doc
  * Bump shlibs to >= 0.3.2.
  * Stop passing --buildsystem=cmake to dh, as there is only the CMake
    buildsystem upstream now.
  * Tighten the -data dependency in the library package.
  * Stop installing manual-main.txt in liblensfun-doc, as it's just one source
    of the API docs.
  * Install the documentation examples in liblensfun-dev, making sure to not
    compress them.
  * Backport upstream commit 3f74b78e4ee9f1d400ebbf2b9093a0f9c48c6307 to fix
    the Database unit test without an already installed lensfun; patch
    upstream_Use-database-in-source-directory-while-running-tests.patch.
  * Backport upstream commit 9ec857bb403accc262a9b5a9c2921b5c064fc9c8 to fix
    DESTDIR installation for the python stuff; patch
    upstream_Patch-47-respect-DESTDIR-when-installing-python-stuf.patch
  * Pass -DBUILD_TESTS=ON to cmake to enable the unit tests, now that all of
    them should work.

 -- Pino Toscano <pino@debian.org>  Sun, 10 Jan 2016 16:06:26 +0100

lensfun (0.2.8-3) unstable; urgency=medium

  * Team upload.
  * Set "Multi-Arch: foreign" for liblensfun-data, to help in multiarch
    installations. (Closes: #785315)
  * Bump Standards-Version to 3.9.6, no changes required.
  * Update watch file (add .gz extension).
  * Pass --list-missing to dh_install, to spot potentially uninstalled files.

 -- Pino Toscano <pino@debian.org>  Thu, 07 Jan 2016 17:54:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,23 @@
 Source: lensfun
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
-Uploaders: Mark Purcell <msp@debian.org>
-Build-Depends: debhelper (>= 9), cmake, pkg-config, python, libglib2.0-dev,
- libpng-dev
-Build-Depends-Indep: doxygen
-Standards-Version: 3.9.5
+Uploaders: Mark Purcell <msp@debian.org>,
+ Pino Toscano <pino@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake, pkg-config, python3, libglib2.0-dev,
+ dh-python,
+ doxygen,
+ python3-docutils,
+Standards-Version: 4.5.1
 Section: libs
-Homepage: http://lensfun.sourceforge.net
-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/lensfun/trunk
-Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/lensfun/trunk
+Rules-Requires-Root: no
+Homepage: https://lensfun.github.io/
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun
+Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun.git
 
 Package: liblensfun-dev
 Section: libdevel
 Architecture: any
-Depends: liblensfun0 (= ${binary:Version}), ${misc:Depends}
+Depends: liblensfun1 (= ${binary:Version}), ${misc:Depends}
 Description: Lens Correction library - Development files
  Lensfun is an opensource database of photographic lenses and their
  characteristics. It contains three kinds of objects:
@@ -34,9 +37,11 @@
  .
  This package contains the development files.
 
-Package: liblensfun0
+Package: liblensfun1
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, liblensfun-data
+Depends: ${shlibs:Depends}, ${misc:Depends},
+ liblensfun-data-v1 (>= ${source:Version})
+Multi-Arch: same
 Description: Lens Correction library - Runtime files
  Lensfun is an opensource database of photographic lenses and their
  characteristics. It contains three kinds of objects:
@@ -56,9 +61,10 @@
  .
  This package contains the runtime files to access the library.
 
-Package: liblensfun-data
+Package: liblensfun-data-v1
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Lens Correction library - Data
  Lensfun is an opensource database of photographic lenses and their
  characteristics. It contains three kinds of objects:
@@ -81,7 +87,7 @@
 Package: liblensfun-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, libjs-mathjax
 Description: Lens Correction library - Documentation
  Lensfun is an opensource database of photographic lenses and their
  characteristics. It contains three kinds of objects:
@@ -101,4 +107,48 @@
  .
  This package contains the documentation.
 
+Package: liblensfun-bin
+Section: utils
+Architecture: any
+Depends: python3, python3-lensfun (= ${binary:Version}), ${misc:Depends}
+Description: Lens Correction library - Utilities
+ Lensfun is an opensource database of photographic lenses and their
+ characteristics. It contains three kinds of objects:
+  * mounts
+  * cameras
+  * lenses
+ .
+ It is used in various photo-related software in which it allows the
+ correction of various artifacts:
+  * distortion
+  * transveral (also known as lateral) chromatic aberrations
+  * vignetting
+  * colour contribution of the lens (correcting said "yellowish" or "blueish"
+    images)
+ .
+ It provides a way to read and search for specific things in the database.
+ .
+ This package contains the utilities.
 
+Package: python3-lensfun
+Section: python
+Architecture: any
+Depends: liblensfun1 (= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
+Description: Lens Correction library - Python3 module
+ Lensfun is an opensource database of photographic lenses and their
+ characteristics. It contains three kinds of objects:
+  * mounts
+  * cameras
+  * lenses
+ .
+ It is used in various photo-related software in which it allows the
+ correction of various artifacts:
+  * distortion
+  * transveral (also known as lateral) chromatic aberrations
+  * vignetting
+  * colour contribution of the lens (correcting said "yellowish" or "blueish"
+    images)
+ .
+ It provides a way to read and search for specific things in the database.
+ .
+ This package contains the Python3 'lensfun' module.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH_CPU),amd64)
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=ON -DBUILD_FOR_SSE2=ON
else
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=OFF -DBUILD_FOR_SSE2=OFF
endif

%:
	dh $@ --with=python3

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DOC=ON -DCMAKE_INSTALL_DOCDIR="/usr/share/doc/liblensfun-doc/html" -DBUILD_TESTS=ON $(EXTRA_CMAKE_ARGS)

override_dh_auto_clean:
	find -name "*.pyc" -exec rm -f '{}' \;
	dh_auto_clean

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%lensfun-$1.tar.gz%" \
  https://github.com/lensfun/lensfun/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
